require 'vikiwikiplugin'

module VikiWiki
	module Plugins
		class RubyInstance
			def initialize(sys)
				@sys = sys
				@name = @sys.page.name.dup
				@text = @sys.page.load.dup
				@path = @sys.page.path.dup
			end
		end
		class Ruby
			include BaseModule
			def ondesc; <<DSC; end
The plugin can retrieve the result of the ruby script.
{{{
#ruby <<EOS
script...
EOS
DSC

			def safe; 2 ; end
			def onview
				mode = @id == 'wiki'
				mode = true if @sys['SAFE'] >= safe()-1
				@inst = RubyInstance::new(@sys) unless @inst
				exp = @prms.first.untaint
				t = Thread.new {
					safelevel = 4 + @sys['SAFE']
					safelevel = safelevel < $SAFE ? $SAFE : safelevel > 4 ? 4 : safelevel
					$SAFE = safelevel
					@inst.instance_eval(exp)
				}
				text = t.value
				if mode then
					if @inline then
						text = Parser::trans_html_inline(@sys, text)
					else
						text = Parser::trans_html(@sys, text)
					end
				end
				return text
			end
		end
	end
end
